property ancestor, pIncludeRolloverState, pNextPrev

on beginSprite me
  if pIncludeRolloverState then
    set numTrans to 3
  else
    set numTrans to 2
  end if
  set togSty to 0
  set ancestor to new(script "Bitmap But 1", the spriteNum of me, numTrans, togSty)
end

on MouseUpAction me
  if pNextPrev = #next then
    go(#next)
  else
    go(#previous)
  end if
end

on MouseDownAction me
  nothing()
end

on MouseEnterAction me
  nothing()
end

on MouseLeaveAction me
  nothing()
end

on getPropertyDescriptionList me
  set description to [:]
  addProp(description, #pNextPrev, [#default: #next, #format: #symbol, #comment: "Next or Previous", #range: [#next, #previous]])
  addProp(description, #pIncludeRolloverState, [#default: 1, #format: #boolean, #comment: "Include Rollover State"])
  return description
end

on getBehaviorDescription me
  set endChar to offset("--END OF HEADER", the text of me)
  set endLine to the number of lines in char 1 to endChar of the text of me - 1
  set description to line 1 to endLine of the text of me
  repeat with whichLine = endLine down to 1
    if line whichLine of description = EMPTY then
      delete line whichLine of description
    end if
  end repeat
  delete line 1 of description
  return description
end
