on MenuHelpOn
  go("Menu.Help")
end

on MenuHelpOff
  global gInitialMenuHelpOn
  set gInitialMenuHelpOn to 1
  go("Menu.Simple")
end

on GetTextDescription textFileName
  set textIndex to field "TextsIndex"
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "@"
  repeat with whichLine = 1 to the number of lines in textIndex
    if item 1 of line whichLine of textIndex = textFileName then
      set item2 to item 2 of line whichLine of textIndex
      set the itemDelimiter to previousItemDelimiter
      return item2
    end if
  end repeat
  set the itemDelimiter to previousItemDelimiter
  return EMPTY
end

on GetPhototDescription photoFileName
  set photoIndex to field "PhotosIndex"
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "@"
  repeat with whichLine = 1 to the number of lines in photoIndex
    if item 1 of line whichLine of photoIndex = photoFileName then
      set item2 to item 2 of line whichLine of photoIndex
      set the itemDelimiter to previousItemDelimiter
      return item2
    end if
  end repeat
  set the itemDelimiter to previousItemDelimiter
  return EMPTY
end

on getTextFileName textName
  set textIndex to field "TextsIndex"
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "@"
  repeat with whichLine = 1 to the number of lines in textIndex
    if item 1 of line whichLine of textIndex = textName then
      set item3 to item 3 of line whichLine of textIndex
      set the itemDelimiter to previousItemDelimiter
      return item3
    end if
  end repeat
  set the itemDelimiter to previousItemDelimiter
  return EMPTY
end

on GetPhototFileName photoName
  set photoIndex to field "PhotosIndex"
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "@"
  repeat with whichLine = 1 to the number of lines in photoIndex
    if item 1 of line whichLine of photoIndex = photoName then
      set item3 to item 3 of line whichLine of photoIndex
      set the itemDelimiter to previousItemDelimiter
      return item3
    end if
  end repeat
  set the itemDelimiter to previousItemDelimiter
  return EMPTY
end

on SetPreviousSection
  global gPreviousSection
  set gPreviousSection to GetCurrentMainSection()
end

on GetCurrentMainSection
  set currentSubSection to getLabel()
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "."
  set the itemDelimiter to previousItemDelimiter
  return item 1 of currentSubSection
end
