property pDetailType
global gCurrentText, gCurrentPhoto, gCurrentVideo

on beginSprite me
  set previousItemDelimiter to the itemDelimiter
  set the itemDelimiter to "."
  set rootName to item 1 of the name of the member of sprite the spriteNum of me
  set the itemDelimiter to previousItemDelimiter
  case pDetailType of
    #text:
      set gCurrentText to rootName
    #photo:
      set gCurrentPhoto to rootName
    #video:
      set gCurrentVideo to rootName
  end case
end

on getPropertyDescriptionList me
  set description to [:]
  addProp(description, #pDetailType, [#default: #text, #format: #symbol, #comment: "Which gCurrent", #range: [#text, #photo, #video]])
  return description
end

on getBehaviorDescription me
  set endChar to offset("--END OF HEADER", the text of me)
  set endLine to the number of lines in char 1 to endChar of the text of me - 1
  set description to line 1 to endLine of the text of me
  repeat with whichLine = endLine down to 1
    if line whichLine of description = EMPTY then
      delete line whichLine of description
    end if
  end repeat
  delete line 1 of description
  return description
end
