property pHowLongToWait, pStartTime
global gInitialMenuHelpOn

on beginSprite me
  if gInitialMenuHelpOn then
    set pStartTime to the timer
  end if
end

on exitFrame
  if gInitialMenuHelpOn then
    if the timer > (pStartTime + (pHowLongToWait * 60)) then
      set gInitialMenuHelpOn to 0
      go(#next)
    else
      go(the frame)
    end if
  else
    go(#loop)
  end if
end

on getPropertyDescriptionList me
  set description to [:]
  addProp(description, #pHowLongToWait, [#default: "15", #format: #integer, #comment: "How Long to Wait in Seconds"])
  return description
end

on getBehaviorDescription me
  set endChar to offset("--END OF HEADER", the text of me)
  set endLine to the number of lines in char 1 to endChar of the text of me - 1
  set description to line 1 to endLine of the text of me
  repeat with whichLine = endLine down to 1
    if line whichLine of description = EMPTY then
      delete line whichLine of description
    end if
  end repeat
  delete line 1 of description
  return description
end
